//
//	fpapi.h
//
//		FinePrint API main header file
//
//		Copyright (c) 1999-2000 FinePrint Software
//		All Rights Reserved.
//
#ifndef inc_fpapi
#define inc_fpapi
#include "fpdefs.h"

// opaque handles into FinePrint API
typedef DWORD HFinePrint;		// session handle from fpOpen
typedef DWORD HFpStat;			// stationery handle from fpCreateStationery

// job count structure
struct FpJobCount {
	DWORD	cJobsPending;		// number of print jobs queued in the Dispatcher
	DWORD	cJobsDeferred;		// number of print jobs queued in the FinePrint UI
	DWORD	cJobsCumulative;	// cumulative number of print jobs handled
								// since Dispatcher startup
};

// job status structure
struct FpJobStatus {
	BOOL	fAppTerm;			// =1 if the printing app has terminated
	BOOL	fJobStarted;		// =1 if the print job started (StartDoc)
	BOOL	fJobCompleted;		// =1 if the print job completed (EndDoc)
	BOOL	fTimeout;			// =1 if we timed out waiting for the job
};

// function prototypes
#ifdef __cplusplus
extern "C" {
#endif

void __stdcall		fpClearCallbackDll (HFinePrint hfp);
FpError __stdcall	fpClose (HFinePrint hfp, BOOL fDeleteJobs);
FpError __stdcall	fpCloseStationery (HFinePrint hfp, HFpStat hStat);
FpError __stdcall	fpCreateStationery (
						HFinePrint	hfp,
						LPCTSTR		pszStat,
						HFpStat		*phStat);
FpError __stdcall	fpDeleteStationery (HFinePrint hfp, LPCTSTR pszStat);
FpError __stdcall	fpDisplayDialog (HFinePrint hfp, DWORD *pdwDlg);
FpError __stdcall	fpGetFinePrinterName (
						int		iPrinter,
						LPTSTR	pszFinePrinter);
FpError __stdcall	fpGetJobCount (HFinePrint hfp, FpJobCount *pjc);
DWORD __stdcall		fpGetLayoutAttr (
						HFinePrint	hfp,
						eLayoutItem	li,
						void		*pAttr,
						DWORD		cbAttr);
DWORD __stdcall		fpGetStationeryAttr (
						HFinePrint		hfp,
						HFpStat			hStat,
						eStatItem		si,
						eStatItemAttr	sia,
						void			*pAttr,
						DWORD			cbAttr);
DWORD __stdcall		fpGetVersion ();
DWORD __stdcall		fpGetVersionReq ();
FpError __stdcall	fpOpen (LPCTSTR pszFinePrinter, HFinePrint *phfp);
FpError __stdcall	fpOpenStationery (
						HFinePrint	hfp,
						LPCTSTR		pszStat,
						HFpStat		*phStat);
FpError __stdcall	fpPrintAllJobs (
						HFinePrint	hfp,
						LPCTSTR		pszOutputFile,
						BOOL		fShowProgress,
						BOOL		fDeleteJobsWhenDone);
FpError __stdcall	fpSaveSettings (HFinePrint hfp);
FpError __stdcall	fpSetCallbackDll (
						HFinePrint	hfp,
						LPCTSTR		pszCallbackDll,
						DWORD		*pcEntryPoints);
FpError __stdcall	fpSetDeferAll (HFinePrint hfp, BOOL fDeferAll);
FpError __stdcall	fpSetDestPrinterAttr (
						HFinePrint	hfp,
						LPCTSTR		pszDestPrinter,
						LPCTSTR		pszSetting,
						DWORD		dwValue);
FpError __stdcall	fpSetLayoutAttr (
						HFinePrint	hfp,
						eLayoutItem	li,
						const void	*pAttr);
FpError __stdcall	fpSetShowDlg (
						HFinePrint	hfp,
						DWORD		dwShowDlg);
FpError __stdcall	fpSetStationeryAttr (
						HFinePrint		hfp,
						HFpStat			hStat,
						eStatItem		si,
						eStatItemAttr	sia,
						const void		*pAttr);
FpError __stdcall	fpWaitForJob (
						HFinePrint			hfp,
						const FpJobCount	*pjcOrig,
						HANDLE				hProcess,
						DWORD				cSecTimeoutStart,
						DWORD				cSecTimeoutPrint,
						FpJobStatus			*pjs);

#ifdef __cplusplus
};
#endif

#endif
