Attribute VB_Name = "FPDEFS"

'
'       fpdefs.bas
'
'       Copyright (c) 1999 FinePrint Software
'       All Rights Reserved.
'

' layout types (1-up 2-up etc.
Enum eLayoutType
    eLayoutNil = -1         ' sentinel value
    eLayoutBypass           ' passthrough to destination printer
    eLayout1                ' 1-up
    eLayout2                ' 2-up
    eLayout4                ' 4-up
    eLayout8                ' 8-up
    eLayoutBooklet          ' booklet
    eLayoutMax              ' sentinel value
End Enum

' border types
Enum eBorderType
    eBordersNil = -1        ' sentinel value
    eBordersOff             ' off
    eBordersOn              ' on
    eBordersSmart           ' smart
    eBordersMax             ' sentinel value
End Enum

' order types
Enum eOrderType
    eOrderAcross = 1
    eOrderDown = 0
End Enum

' margin types
Enum eMarginType
    eMarginNil = -1         ' sentinel value
    eMarginNone             ' none
    eMarginSmall            ' small
    eMarginMedium           ' medium
    eMarginLarge            ' large
    eMarginOrig             ' original
    eMarginMax              ' sentinel value
End Enum

' dest printer duplex support
Enum eDuplexSupportType
    eDuplexSuppNil = -1     ' sentinel value
    eDuplexSuppUnknown      ' unknown
    eDuplexSuppFaceUp       ' manual face up
    eDuplexSuppFaceDown     ' manual face down
    eDuplexSuppHardware     ' hardware duplex
    eDuplexSuppMax          ' sentinel value
End Enum

' dest printer duplex settings
Enum eDuplexType
    eDuplexNil = -1         ' sentinel value
    eDuplexNone             ' 1-sided printing
    eDuplexLong             ' 2-sided bind on long side
    eDuplexShort            ' 2-sided bind on short side
    eDuplexDflt             ' current printer setting
    eDuplexMax              ' sentinel value
End Enum

' dest printer orientation
Public Const DMORIENT_AUTOMATIC = 3

' when to display the UI dialog
Enum eShowDlgType
    ShowDlg_Nil = -1        ' sentinel value
    ShowDlg_Early           ' show UI before spooling
    ShowDlg_Late            ' show UI after spooling
    ShowDlg_Never           ' do not show UI
    ShowDlg_Max             ' sentinel value
End Enum

' different ways to draw colored text
Enum eColTextType
    eColTextNil = -1        ' sentinel value
    eColTextNormal          ' draw normally
    eColTextPath            ' draw as a filled path
    eColTextBlack           ' convert to black and draw normally
    eColTextMax             ' sentinel value
End Enum

' stationery items
Enum eStatItem
    esiNil = -1             ' sentinel value
    esiHeader               ' header
    esiFooter               ' footer
    esiWatermark            ' watermark
    esiMax                  ' sentinel value
End Enum

' stationery item attributes
Enum eStatItemAttr
    esiaNil = -1            ' sentinel value
    esiaText                ' text of item (LPTSTR)
    esiaFont                ' font of item (LOGFONT)
    esiaColor               ' text color of item (COLORREF)
    esiaMax                 ' sentinel value
End Enum

' layout items
Enum eLayoutItem
    eliNil = -1             ' sentinel value
    eliLayout               ' N-up
    eliBorders              ' borders
    eliOrder                ' page ordering (4-up and 8-up only)
    eliStationery           ' stationery
    eliForm                 ' form
    eliDestPrinter          ' destination printer
    eliMargins              ' margins
    eliDuplex               ' double-sided
    eliCopies               ' number of copies
    eliMax                  ' sentinel value
End Enum

' dest printer page rotation
Enum ePageRotation
    eprNil = -1             ' sentinel value
    eprEntire               ' rotate entire page
    eprBanded               ' rotate page in bands
    eprNone                 ' do not rotate
    eprMax                  ' sentinel value
End Enum

' special return values from the FinePrint UI
Public Const IDDEFER = &HAAAA      ' Defer button was pressed
Public Const IDDEFERALL = &HAAAB   ' Defer All button was pressed

' registry key names for dest printer settings
Public Const stDestColoredText = "ColoredText"
Public Const stDestDuplex = "Duplex"
Public Const stDestDuplexSupport = "DuplexSupport"
Public Const stDestDuplexType = "DuplexType"
Public Const stDestExtraMargin = "AddMargin"
Public Const stDestLandDupCorr = "DuplexCorrection"
Public Const stDestOrientation = "Orientation"
Public Const stDestPageRotation = "PageRotation"
Public Const stDestPdfFontCorr = "EmbFontGraphics"
Public Const stDestReverse = "Reverse"

' FinePrint error codes
Enum FpError
    eFpeNil = -1            ' sentinel value
    eFpeOK                  ' no error
    eFpeNotImplemented      ' functionality is not implemented
    eFpeBadParam            ' invalid parameter
    eFpeNoMem               ' out of memory
    eFpeBadVersion          ' incompatible FinePrint version
    eFpeNotFound            ' item was not found
    eFpeNoDispatcher        ' could not locate the dispatcher
    eFpeDispatcherErr       ' an error occurred in the dispatcher
    eFpeNoUi                ' could not locate the UI
    eFpeUiErr               ' an error occurred in the UI
    eFpeTimeout             ' a timeout expired
    eFpePrinter             ' error on the dest printer
    eFpeIo                  ' file I/O error
    eFpeMax                 ' sentinel value
End Enum
